<?php

namespace App\Service;

use App\Aggregate\AcceptOrderCommand;
use Symfony\Component\Serializer\SerializerInterface;
use Symfony\Contracts\HttpClient\HttpClientInterface;

class OrderService
{
    public function __construct(
        private readonly HttpClientInterface $crmClient,
        private readonly SerializerInterface $serializer,
    ) {
    }

    public function acceptOrder(AcceptOrderCommand $command)
    {
        $this->crmClient->request('POST', '/order', [
            'body' => $this->serializer->serialize($command->order, format: 'json')
        ]);
    }
}
